//==UserScript==
// @name          PagePlaylist
// @description	  Mostra un piccolo player in flash con una playlist di tutti i link mp3 presenti nella pagina corrente.
// @namespace     http://www.webalice.it/disagio/
// @include       *
//by Enrico Battocchi
// ==/UserScript==

(
function() {


/**************************************************
 * The code below came directly from 
 *   http://www.youngpup.net/
 * dom-drag.js
 * 09.25.2001
 * www.youngpup.net
 **************************************************
 * 10.28.2001 - fixed minor bug where events
 * sometimes fired off the handle, not the root.
 **************************************************/

var Drag = {

	obj : null,

	init : function(o, oRoot, minX, maxX, minY, maxY, bSwapHorzRef,
bSwapVertRef, fXMapper, fYMapper)
	{
		o.onmousedown	= Drag.start;

		o.hmode			= bSwapHorzRef ? false : true ;
		o.vmode			= bSwapVertRef ? false : true ;

		o.root = oRoot && oRoot != null ? oRoot : o ;

		if (o.hmode  && isNaN(parseInt(o.root.style.left  )))
o.root.style.left   = "0px";
		if (o.vmode  && isNaN(parseInt(o.root.style.top   )))
o.root.style.top    = "0px";
		if (!o.hmode && isNaN(parseInt(o.root.style.right )))
o.root.style.right  = "0px";
		if (!o.vmode && isNaN(parseInt(o.root.style.bottom)))
o.root.style.bottom = "0px";

		o.minX	= typeof minX != 'undefined' ? minX : null;
		o.minY	= typeof minY != 'undefined' ? minY : null;
		o.maxX	= typeof maxX != 'undefined' ? maxX : null;
		o.maxY	= typeof maxY != 'undefined' ? maxY : null;

		o.xMapper = fXMapper ? fXMapper : null;
		o.yMapper = fYMapper ? fYMapper : null;

		o.root.onDragStart	= new Function();
		o.root.onDragEnd	= new Function();
		o.root.onDrag		= new Function();
	},

	start : function(e)
	{
		var o = Drag.obj = this;
		e = Drag.fixE(e);
		var y = parseInt(o.vmode ? o.root.style.top  : o.root.style.bottom);
		var x = parseInt(o.hmode ? o.root.style.left : o.root.style.right );
		o.root.onDragStart(x, y);

		o.lastMouseX	= e.clientX;
		o.lastMouseY	= e.clientY;

		if (o.hmode) {
			if (o.minX != null)	o.minMouseX	= e.clientX - x + o.minX;
			if (o.maxX != null)	o.maxMouseX	= o.minMouseX + o.maxX - o.minX;
		} else {
			if (o.minX != null) o.maxMouseX = -o.minX + e.clientX + x;
			if (o.maxX != null) o.minMouseX = -o.maxX + e.clientX + x;
		}

		if (o.vmode) {
			if (o.minY != null)	o.minMouseY	= e.clientY - y + o.minY;
			if (o.maxY != null)	o.maxMouseY	= o.minMouseY + o.maxY - o.minY;
		} else {
			if (o.minY != null) o.maxMouseY = -o.minY + e.clientY + y;
			if (o.maxY != null) o.minMouseY = -o.maxY + e.clientY + y;
		}

		document.onmousemove	= Drag.drag;
		document.onmouseup		= Drag.end;

		return false;
	},

	drag : function(e)
	{
		e = Drag.fixE(e);
		var o = Drag.obj;

		var ey	= e.clientY;
		var ex	= e.clientX;
		var y = parseInt(o.vmode ? o.root.style.top  : o.root.style.bottom);
		var x = parseInt(o.hmode ? o.root.style.left : o.root.style.right );
		var nx, ny;

		if (o.minX != null) ex = o.hmode ? Math.max(ex, o.minMouseX) :
Math.min(ex, o.maxMouseX);
		if (o.maxX != null) ex = o.hmode ? Math.min(ex, o.maxMouseX) :
Math.max(ex, o.minMouseX);
		if (o.minY != null) ey = o.vmode ? Math.max(ey, o.minMouseY) :
Math.min(ey, o.maxMouseY);
		if (o.maxY != null) ey = o.vmode ? Math.min(ey, o.maxMouseY) :
Math.max(ey, o.minMouseY);

		nx = x + ((ex - o.lastMouseX) * (o.hmode ? 1 : -1));
		ny = y + ((ey - o.lastMouseY) * (o.vmode ? 1 : -1));

		if (o.xMapper)		nx = o.xMapper(y)
		else if (o.yMapper)	ny = o.yMapper(x)

		Drag.obj.root.style[o.hmode ? "left" : "right"] = nx + "px";
		Drag.obj.root.style[o.vmode ? "top" : "bottom"] = ny + "px";
		Drag.obj.lastMouseX	= ex;
		Drag.obj.lastMouseY	= ey;

		Drag.obj.root.onDrag(nx, ny);
		return false;
	},

	end : function()
	{
		document.onmousemove = null;
		document.onmouseup   = null;
		Drag.obj.root.onDragEnd(	parseInt(Drag.obj.root.style[Drag.obj.hmode
? "left" : "right"]),
									parseInt(Drag.obj.root.style[Drag.obj.vmode ? "top" : "bottom"]));
		Drag.obj = null;
	},

	fixE : function(e)
	{
		if (typeof e == 'undefined') e = window.event;
		if (typeof e.layerX == 'undefined') e.layerX = e.offsetX;
		if (typeof e.layerY == 'undefined') e.layerY = e.offsetY;
		return e;
	}
};



	function dom_setStyle(elt, str) {
        elt.setAttribute("style", str);   
       	    }

	 function dom_getElements(node, elt) {
	    	var list = node.getElementsByTagName(elt);
    		return (list.length) ? list : node.getElementsByTagNameNS("*", elt); 
	    }

	 var gReq; // XHR object
	 var gRss_src;

	try {
	        gReq = (typeof(XMLHttpRequest) == "object") ?
	             new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHTTP");
	    } catch (e) {
	        window.status = "XHR instantiation: " + (e.message) ? e.message : e;
	    }

    function rss_discover() {
        var src = null;
	if (location.href.indexOf("del.icio.us") != -1 && location.href.indexOf("mp3") != -1)
		{
        	var rss = document.getElementsByTagName("link");
	        for (var i=0; i<rss.length; i++) {
	            var type = rss[i].getAttribute("type");
	            if (type && type.toLowerCase() == "application/rss+xml") { 
	                src = rss[i].getAttribute("href");
        	    }
	            if (src) break;
	        }
	}
	if (!src) src = 1;
        return src;
    }
	
    function rss_req(src) {
        if (! src) return;
        try {
			gReq.onreadystatechange = rss_response;
			gReq.open("GET", src);
			gReq.send(null);
        } catch(e) {
            window.status = (e.message) ? e.message : e.toString();
        }
    }

    function rss_response() {
        // only if req is "loaded"
        if (gReq.readyState == 4) {
            // only if "OK"
            if (gReq.status == 200) {
                // handle result
                rss_render(gReq.responseXML);
            } else {
                create_from_page();
            }
        }
    }



function rss_render(DOM){
		
	page_links = DOM.getElementsByTagName("item");
	par += "<title>Playlist " + document.title +"</title><trackList>";
	for (var i=0; i<page_links.length; i++){
	var linkmp3 = page_links[i].getElementsByTagName("link")[0].firstChild.nodeValue;
	if (linkmp3.match(/\.mp3$/i)) {
			showplayer = true;
			par += "<track><location>" + linkmp3 +"</location><annotation>" + linkmp3.substring(linkmp3.lastIndexOf("/")+1, linkmp3.lastIndexOf(".mp3")) + "</annotation></track>";
			}
		}

	par += "</trackList></playlist>";
	if (showplayer)  displayBox();
	Drag.init(close,box);

	}


	var showplayer = false;
	par="<?xml version=\"1.0\" encoding=\"UTF-8\"?><playlist version=\"1\" xmlns = \"http://xspf.org/ns/0/\">";
	
	//if (location.href.indexOf("del.icio.us") != -1 && location.href.indexOf("mp3") != -1)
	//	{
			gRss_src = rss_discover();
			    if (gRss_src) {
				 rss_req(gRss_src);
			    }
	//		
	//	}
	//else
	//	create_from_page();
	
function create_from_page(){
	page_links = document.links;		
	par += "<title>Playlist della pagina " + document.title +"</title><trackList>";
	for (var i=0; i<page_links.length; i++){
	var linkmp3 = page_links[i].href
	if (linkmp3.match(/\.mp3$/i)) {
			showplayer = true;
			par += "<track><location>" + linkmp3 +"</location><annotation>" + linkmp3.substring(linkmp3.lastIndexOf("/")+1, linkmp3.lastIndexOf(".mp3")) + "</annotation></track>";
			}
		}
	par += "</trackList></playlist>";
	if (showplayer)   displayBox();
	Drag.init(close,box);

	
}	

	
function displayBox(){

var expander = function() {
        	// closed state
        	if (box.style.height == "12px") {
            	box.style.height = "170px";
            	//box.style.overflow = "auto";
            	//close.style.right = "1px";
            	//open.style.right = "1px";
            	open.firstChild.nodeValue = "<";
		//close.style.visibility="hidden";
			} else {
            	box.style.height = "12px";
            	//box.style.overflow = "hidden";
            	//close.style.right = "1px";
            	//open.style.right = "1px";
            	open.firstChild.nodeValue = ">";
		//close.style.visibility="visible";
			}
		};

	var collapser = function() {		        	
		// closed state
        	if (box.style.width == "430px") {
            	span.style.width = "0px";
            	box.style.width = "10px";
		box.style.height = "12px";
            	//box.style.overflow = "auto";
            	//close.style.right = "1px";
            	//open.style.right = "1px";
            	//close.firstChild.nodeValue = "o";
		//close.style.visibility="hidden";
			} else {
            	box.style.width = "430px";
            	span.style.width = "400px";
            	//box.style.overflow = "hidden";
            	//close.style.right = "1px";
            	//open.style.right = "1px";
            	//close.firstChild.nodeValue = "x";
		//close.style.visibility="visible";
			}
		};




	box = document.createElement("div");
	span = document.createElement("div");
	titolo = "Playlist della pagina " + document.title;
	url = "chrome://pageplaylist/content/player.swf?single_music_playlist="+escape(par)+"&autoload=true";
	width = 400
	height = 170
	obje = document.createElement("object");
	obje.id="myplayer";
	obje.type="application/x-shockwave-flash";
	obje.data=url;
	obje.width = width;
	obje.height = height;
	var par1 = document.createElement("param");
	par1.name="movie";
	par1.value=url;
	var par2 = document.createElement("param");
	par1.name="wmode";
	par1.value="transparent";	
	var emb = document.createElement("embed");
	emb.src=url;
	emb.width = width;
	emb.height = height;
	emb.name="myplayer";
	obje.appendChild(par1);
	obje.appendChild(par2);
	obje.appendChild(emb);
	span.appendChild(obje);
	close = document.createElement("div");
        dom_setStyle(close,"position:absolute;top:1px;left:1px;width:10px;height:10px;border:0px solid;line-height:8px;text-align:center;cursor:pointer;");
	close.setAttribute("title","Double click to open/close\nClick and drag to move");
        close.ondblclick = collapser;
	img = document.createElement("img");
	img.src = "chrome://pageplaylist/content/notina.png";
        //close.appendChild(document.createTextNode("o"));
	close.appendChild(img);
	open  = document.createElement("div");
	dom_setStyle(open,
	"position:absolute;top:1px;left:15px;height:10px;width:10px;border:0px solid ;line-height:8px;text-align:center;cursor:pointer;");
	open.setAttribute("title","click to maximize/minimize");
	open.appendChild(document.createTextNode(">"));
	//open.appendChild(img);
	open.onclick = expander;
	control = document.createElement("div");
	dom_setStyle(control,"position:absolute;top:1px;left:1px;");
	control.appendChild(close);
	control.appendChild(open);
	dom_setStyle(span,"position:absolute;top:1px;left:28px;width:400px;height:170px;");
	box.appendChild(control);
	box.appendChild(span);
	box.name = "box";
	dom_setStyle(box,"position:fixed;z-index:99;top:1px;left:1px;border:1px solid;padding:2px;text-align:left;background-color:#c0c0c0; opacity: 0,50 ;font:8pt sans-serif;overflow:hidden;width:10px;height:12px;margin-bottom:15px;");
	document.getElementsByTagName("body")[0].appendChild(box);
	
	}
	




	
})();